CREATE TABLE IF NOT EXISTS `#__cu3er__defaults` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `slideshow_id` int(11) NOT NULL,
  `duration` varchar(50) DEFAULT NULL,
  `color` varchar(20) DEFAULT NULL,
  `caption` varchar(255) DEFAULT NULL,
  `link` varchar(255) DEFAULT NULL,
  `target` varchar(20) DEFAULT NULL,
  `heading` text,
  `paragraph` text,
  `dlink` varchar(255) DEFAULT NULL,
  `dtarget` varchar(20) DEFAULT NULL,
  `type` varchar(5) DEFAULT NULL,
  `columns` int(11) DEFAULT NULL,
  `rows` int(11) DEFAULT NULL,
  `type2D` varchar(50) DEFAULT NULL,
  `flipAngle` int(11) DEFAULT NULL,
  `flipOrder` int(11) DEFAULT NULL,
  `flipShader` varchar(50) DEFAULT NULL,
  `flipOrderFromCenter` varchar(20) DEFAULT NULL,
  `flipDirection` varchar(50) DEFAULT NULL,
  `flipColor` varchar(30) DEFAULT NULL,
  `flipBoxDepth` varchar(50) DEFAULT NULL,
  `flipDepth` varchar(50) DEFAULT NULL,
  `flipEasing` varchar(50) DEFAULT NULL,
  `flipDuration` varchar(50) DEFAULT NULL,
  `flipDelay` varchar(50) DEFAULT NULL,
  `flipDelayRandomize` varchar(50) DEFAULT '0',
  `align_pos` varchar(5) DEFAULT NULL,
  `x` varchar(50) DEFAULT NULL,
  `y` varchar(50) DEFAULT NULL,
  `scaleX` varchar(50) DEFAULT NULL,
  `scaleY` varchar(50) DEFAULT NULL,
  `salign_pos` varchar(5) DEFAULT NULL,
  `sx` varchar(50) DEFAULT NULL,
  `sy` varchar(50) DEFAULT NULL,
  `swidth` varchar(50) DEFAULT NULL,
  `sheight` varchar(50) DEFAULT NULL,
  `corner_TL` varchar(20) DEFAULT NULL,
  `corner_TR` varchar(20) DEFAULT NULL,
  `corner_BL` varchar(20) DEFAULT NULL,
  `corner_BR` varchar(20) DEFAULT NULL,
  `thumb_width` varchar(20) DEFAULT NULL,
  `thumb_height` varchar(20) DEFAULT NULL,
  `transparent` varchar(15) DEFAULT NULL,
  `seo_show_image` enum('no','yes') DEFAULT NULL,
  `seo_show_heading` enum('no','yes') DEFAULT NULL,
  `seo_show_paragraph` enum('no','yes') DEFAULT NULL,
  `seo_show_caption` enum('no','yes') DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__cu3er__settings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cu3er_location` varchar(255) NOT NULL,
  `licence` varchar(255) NOT NULL,
  `licence1` varchar(255) NOT NULL,
  `licence2` varchar(255) NOT NULL,
  `licence3` varchar(255) NOT NULL,
  `licence4` varchar(255) NOT NULL,
  `js_location` varchar(255) NOT NULL,
  `version` varchar(10) NOT NULL DEFAULT '0.1',
  `branding` enum('yes','no') NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
INSERT INTO `#__cu3er__settings` (`id`,`version`,`branding`) VALUES (1,'0.1','no') ON DUPLICATE KEY UPDATE `version`='0.1';

CREATE TABLE IF NOT EXISTS `#__cu3er__slides` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `slideshow_id` int(11) NOT NULL,
  `duration` varchar(50) DEFAULT NULL,
  `color` varchar(20) DEFAULT NULL,
  `caption` varchar(255) DEFAULT NULL,
  `link` varchar(255) DEFAULT NULL,
  `target` varchar(20) DEFAULT NULL,
  `heading` text,
  `paragraph` text,
  `dlink` varchar(255) DEFAULT NULL,
  `dtarget` varchar(20) DEFAULT NULL,
  `type` varchar(5) DEFAULT NULL,
  `columns` int(11) DEFAULT NULL,
  `rows` int(11) DEFAULT NULL,
  `type2D` varchar(50) DEFAULT NULL,
  `flipAngle` int(11) DEFAULT NULL,
  `flipOrder` int(11) DEFAULT NULL,
  `flipShader` varchar(50) DEFAULT NULL,
  `flipOrderFromCenter` varchar(20) DEFAULT NULL,
  `flipDirection` varchar(50) DEFAULT NULL,
  `flipColor` varchar(30) DEFAULT NULL,
  `flipBoxDepth` varchar(50) DEFAULT NULL,
  `flipDepth` varchar(50) DEFAULT NULL,
  `flipEasing` varchar(50) DEFAULT NULL,
  `flipDuration` varchar(50) DEFAULT NULL,
  `flipDelay` varchar(50) DEFAULT NULL,
  `flipDelayRandomize` varchar(50) DEFAULT NULL,
  `position` int(11) NOT NULL,
  `image` varchar(255) DEFAULT NULL,
  `align_pos` varchar(255) DEFAULT NULL,
  `x` varchar(50) DEFAULT NULL,
  `y` varchar(50) DEFAULT NULL,
  `scaleX` varchar(50) DEFAULT NULL,
  `scaleY` varchar(50) DEFAULT NULL,
  `transparent` varchar(15) NOT NULL,
  `published` tinyint(1) NOT NULL,
  `ordering` int(4) NOT NULL,
  `use_image` enum('yes','no') NOT NULL,
  `seo_show_image` enum('yes','no') NOT NULL,
  `seo_show_heading` enum('yes','no') NOT NULL,
  `seo_show_paragraph` enum('yes','no') NOT NULL,
  `seo_show_caption` enum('yes','no') NOT NULL,
  `seo_text` text NOT NULL,
  `seo_img_alt` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__cu3er__slideshows` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `width` int(11) NOT NULL,
  `height` int(11) NOT NULL,
  `type` varchar(20) NOT NULL,
  `background` varchar(20) NOT NULL,
  `images_folder` varchar(255) NOT NULL,
  `fonts_folder` varchar(255) NOT NULL,
  `content` text NOT NULL,
  `xml_location` varchar(255) NOT NULL,
  `bg_image` varchar(255) DEFAULT NULL,
  `bg_align_to` varchar(10) DEFAULT NULL,
  `bg_align_pos` varchar(10) DEFAULT NULL,
  `bg_x` varchar(50) DEFAULT NULL,
  `bg_y` varchar(50) DEFAULT NULL,
  `bg_scaleX` varchar(50) DEFAULT NULL,
  `bg_scaleY` varchar(50) DEFAULT NULL,
  `bg_use_image` varchar(15) DEFAULT NULL,
  `backgroundType` varchar(20) DEFAULT NULL,
  `sdw_show` varchar(20) DEFAULT NULL,
  `sdw_use_image` varchar(20) DEFAULT NULL,
  `sdw_color` varchar(20) DEFAULT NULL,
  `sdw_alpha` varchar(50) DEFAULT NULL,
  `sdw_blur` varchar(50) DEFAULT NULL,
  `sdw_corner_tl` varchar(30) DEFAULT NULL,
  `sdw_corner_tr` varchar(30) DEFAULT NULL,
  `sdw_corner_bl` varchar(30) DEFAULT NULL,
  `sdw_corner_br` varchar(30) DEFAULT NULL,
  `sdw_image` varchar(255) DEFAULT NULL,
  `pr_image` varchar(255) DEFAULT NULL,
  `pr_width` varchar(20) DEFAULT NULL,
  `pr_height` varchar(20) DEFAULT NULL,
  `pr_align_to` varchar(20) DEFAULT NULL,
  `pr_align_pos` varchar(20) DEFAULT NULL,
  `pr_x` varchar(50) DEFAULT NULL,
  `pr_y` varchar(50) DEFAULT NULL,
  `pr_scaleX` varchar(50) DEFAULT NULL,
  `pr_scaleY` varchar(50) DEFAULT NULL,
  `pr_loader_direction` varchar(20) DEFAULT NULL,
  `pr_alpha_loader` varchar(50) DEFAULT NULL,
  `pr_alpha_bg` varchar(5) DEFAULT NULL,
  `pr_tint_loader` varchar(15) DEFAULT NULL,
  `pr_tint_bg` varchar(15) DEFAULT NULL,
  `br_align_to` varchar(20) DEFAULT NULL,
  `br_align_pos` varchar(20) DEFAULT NULL,
  `br_x` varchar(20) DEFAULT NULL,
  `br_y` varchar(20) DEFAULT NULL,
  `force_js` enum('true','false') DEFAULT 'false',
  `modified` datetime DEFAULT NULL,
  `published` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
