<?php
/**
 * Joomla! 1.5 component Cu3er
 *
 * @version $Id: slideshow.php 2011-04-12 05:17:53 svn $
 * @author MADEBYPLAY
 * @package Joomla
 * @subpackage Cu3er
 * @license GNU/GPL
 *
 * Cu3er component for Joomla 1.5
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');

// Include Slideshow table
JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');
jimport('joomla.filesystem.file');

class Cu3erModelSlideshow extends JModel {

	/**
	 * Constructor
	 *
	 * @since 1.0
	 */
	function __construct() {
		parent::__construct();
	}    	

	/**
	 * Slideshow data getter method
	 *
	 * @access	public	
	 * @param	int	$cid	ID of a slideshow	
	 * @param	string	$field	field of the table
	 * @return	array	array of slideshow data
	 */
	function getData($cid = null, $field = null) {

		$cid = (!is_null($cid))?$cid:JRequest::getVar('cid');
		$row = & JTable::getInstance('Cu3erSlideshow', 'Table');
		$row->load($cid);
		return (is_null($field))?$row:$row->$field;
	}

	/**
	 * Slideshow settings saver method
	 *
	 * @access	public	
	 * @param	boolean	 $preview true if component generates preview (no saving to db)
	 */
	function save($preview = false) {

		$mainframe = &JFactory::getApplication();
		$row = & JTable::getInstance('Cu3erSlideshow', 'Table');
		$post = JRequest::get('post', 4);

		// setting value of `modified` field from actual date 
            	$datenow = &JFactory::getDate();
	        $row->modified = $datenow->toMySQL();

		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'slideshow_fields.php');

		// handling unchecked checkbox value storing
		foreach ($special_fields as $field => $attr) {
			if ($attr['type'] == 'checkbox' && !JRequest::getVar($field)) {
				//$row->{$field} = (isset($attr['uncheck_value']))?$attr['uncheck_value']:0;
				$post[$field] = (isset($attr['uncheck_value']))?$attr['uncheck_value']:0;
			}
		}

		// setting `published` field to 0 if slideshow is unpublished
		if (!JRequest::getInt('published')) {
			$row->published = 0;
		}

		// setting `content` field to the default value of alt_content (language file) if it's empty
		if (strlen(JRequest::getString('content')) < 1) {
			$post['content'] = JText::_('alt_content');
		}

		// converting posted array values to string (eg checkbox)
		foreach ($post as $name => $value) {
			if (is_array($value)) {
				$post[$name] = implode(",", $value);
			}
		}

		$row->load($post['id']);
		if($post['pr_image'] != '' && $this->hasJavaScript($post['images_folder'])) {
			// generate new preloader image //
			$prImage['image'] = ($this->isImage($post['pr_image'])) ? $post['pr_image'] : $this->stripTrailingSlash($post['images_folder']) . '/' . $post['pr_image'];
			$slideshow_img_dir = JPATH_SITE.DS.(JComponentHelper::getParams('com_media')->get('image_path')).DS.'CU3ER'.DS.$row->id;
			$pr_image = getimagesize($slideshow_img_dir.DS.basename($prImage['image']));
			$post['pr_width'] = $pr_image[0];
			$post['pr_height'] = $pr_image[1];
			$prImage['scalex'] = ($row->pr_scaleX != '') ? $row->pr_scaleX : 1;
			$prImage['scaley'] = ($row->pr_scaleY != '') ? $row->pr_scaleY : 1;
			$prImage['width'] = $post['pr_width'] * $prImage['scalex'];
			$prImage['height'] = $post['pr_height'] * $prImage['scaley'];
			$this->generatePreloaderImage($prImage, $slideshow_img_dir);
		}

		// if task is not preview
		if (!$preview) {

			// binding, checking and storing posted variables to database
			if (!$row->bind($post) || !$row->check() || !$row->store()) {
				$mainframe->redirect('index.php?option=com_cu3er&view=slideshow&cid='.$row->id, $row->getError(), 'error');
			}

		        $row->checkin();

		}

		// cleaning up cache	        
		$cache = &JFactory::getCache('com_cu3er');
	        $cache->clean();

		switch (JRequest::getCmd('task')) {
		        case 'apply':
        		        $msg = 'Changes to Slideshow saved';
        		        $link = 'index.php?option=com_cu3er&view=slideshow&cid='.$row->id;
        		        break;
        		case 'saveAndNew':
		                $msg = 'Slideshow Saved';
                		$link = 'index.php?option=com_cu3er&view=slideshows';
                		break;
		        case 'save':
		        default:
                		$msg = 'Slideshow Saved';
		                $link = 'index.php?option=com_cu3er&view=slideshows';
		                break;
	        }
		
		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'lib'.DS.'cu3erfile.class.php');

		if ($preview) {

			// setting preview array (see Cu3erXML class)
			$prev_array = array(
				'name' => 'slideshow', 
				'params' => $post,
			);
		
			// generation of the CU3ER-preview.xml file
			if (!Cu3erFile::generateXMLFile(JRequest::getInt('id'), null, $prev_array)) {
				$msg = 'Unable to write CU3ER-preview.xml file';
			}

			echo $msg;

		} else {
			// generation of the CU3ER-generated.xml file 
			if (!Cu3erFile::generateXMLFile(JRequest::getInt('id'))) {
				$msg = 'Unable to write CU3ER-generated.xml file';		
			} 
		
			$mainframe->redirect($link, $msg);
		}

	}
	
	function hasJavaScript($path) {
		$rootDir = dirname(dirname(dirname(dirname(dirname(__FILE__)))));
		$tempPath = explode("/", $path);
		$delFlag = true;
		for($i =0; $i<sizeof($tempPath); $i++) {
			if($delFlag) {
				if($tempPath[$i] == 'images') {
					$delFlag = false;
				} else {
					unset($tempPath[$i]);
				}
			}
		}
		$realPath = $rootDir . '/' . implode('/', $tempPath);
		return is_dir($realPath . '/fallback');
	}
	
	function generatePreloaderImage($prImage, $baseUrl) {
		$image = array(
			'image' => $prImage['image'],
			'image_x' => 0,
			'image_y' => 0,
			'image_scaleX' => $prImage['scalex'],
			'image_scaleY' => $prImage['scaley'],
			'image_pos' => 'TL',
			'slide_TL' => '0,0',
			'slide_TR' => $prImage['width'] . ',0',
			'slide_BL' => '0,' . $prImage['height'],
			'slide_BR' => $prImage['width'] . ',' . $prImage['height'],
			'slide_color' => 'transparent',
			'slides_width' => $prImage['width'],
			'slides_height' => $prImage['height']
		);
		$data = JFile::read('http://205.186.138.15/img/wpcu3er/generate_slide.php?' . http_build_query($image));
		// decoding JSON string into array
		$data = json_decode(stripslashes($data), true);
		if($data['success'] == 1) {
			if($data['url_slide'] != '') {
				$preloader = $baseUrl . '/fallback/preloader_image.png';
				$cu3er_image = JFile::read($data['url_slide']);
				chmod($preloader, 0777);
				JFile::write($preloader, $cu3er_image);
			}
		}
	}
	
	function isImage($url) {
		$data = file_get_contents($url);
		return ($data != '') ? true : false;
	}
	
	function stripTrailingSlash($url) {
		return rtrim($url, "/");
;
	}

}
