<?php
/**
 * Joomla! 1.5 component Cu3er
 *
 * @version $Id: import.php 2011-04-12 05:17:53 svn $
 * @author MADEBYPLAY
 * @package Joomla
 * @subpackage Cu3er
 * @license GNU/GPL
 *
 * Cu3er component for Joomla 1.5
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');
jimport('joomla.filesystem.file');

// Include Slideshow table
JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');

class Cu3erModelXMLUpdate extends JModel {


	var $xml = array();
	var $slideshow_id;

	/**
	 * Constructor
	 *
	 * @since 1.0
	 */
	function __construct() {
		parent::__construct();
	}    	


	/**		
	 * Slideshow database loader method
	 *
	 * @access	public	
	 * @param	object $cu3er_xml Cu3erXML object of CU3ER config values
	 */
	function XMLArray2DB($cu3er_xml) {

		$mainframe = &JFactory::getApplication();

		$db = & JFactory::getDBO();
		$slideshow_id = JRequest::getInt('cid');

		// basic redirection link
		$link = 'index.php?option=com_cu3er&view=xmlupdate&cid=' . $slideshow_id;

		// referencing table instances
		$ss_tbl = & JTable::getInstance('Cu3erSlideshow', 'Table');
		$def_tbl = & JTable::getInstance('Cu3erDefault', 'Table');
		$slideshow_id = JRequest::getInt('cid');
		// loading slideshow entry
		$ss_tbl->load($slideshow_id);

		$config =& JComponentHelper::getParams('com_media');

		// binding, checking and storing slideshow data	
		if (!$ss_tbl->bind($cu3er_xml->db_array['slideshows']) || !$ss_tbl->check() || !$ss_tbl->store()) {
			// redirecting with error message
			$mainframe->redirect($link, $ss_tbl->getError(), 'error');
		}

		$ss_tbl->load($slideshow_id);

		// setting Joomla dependent slideshow data
		$ss_tbl->images_folder = JURI::root().($config->get('image_path', 'images/stories')).DS.'CU3ER'.DS.$slideshow_id;
		$ss_tbl->fonts_folder = JURI::root().'components'.DS.'com_cu3er'.DS.'slideshows'.DS.$slideshow_id.DS.'fonts';
		$ss_tbl->xml_location = JURI::root().'components'.DS.'com_cu3er'.DS.'slideshows'.DS.$slideshow_id.DS.$ss_tbl->xml_location;

		// storing new data		
		if (!$ss_tbl->check() || !$ss_tbl->store()) {
			
			$this->deleteRecord('slideshows', $slideshow_id, 'id');
			$mainframe->redirect($link, $def_tbl->getError(), 'error');
		}

		$ss_tbl->checkin();

		// loading slide default entry
		$def_tbl->load($slideshow_id);

		$def_tbl->id = null;

		// binding, checking and storing slide default data	
		if (!$def_tbl->bind($cu3er_xml->db_array['defaults']) || !$def_tbl->check() || !$def_tbl->store()) {
			
			$mainframe->redirect($link, $def_tbl->getError(), 'error');
		}

	        $def_tbl->checkin();

		$msg = 'CU3ER Slideshow updated successfully';

		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'lib'.DS.'cu3erfile.class.php');

		// generating CU3ER-generated.xml file according to the database values		
		if (!Cu3erFile::generateXMLFile($slideshow_id)) {
			$msg = 'Unable to write CU3ER-generated.xml file';		
		}

	        $cache = &JFactory::getCache('com_cu3er');
	        $cache->clean();

		$mainframe->redirect('index.php?option=com_cu3er&view=slideshow&cid=' . $slideshow_id, JText::_($msg));

	}

	/**
	 * Slideshow XML file updater method
	 *
	 * @access	public	
	 */
	function updateXMLFile() {

		require_once(JPATH_COMPONENT.DS.'lib'.DS.'cu3erxml.class.php');	
		require_once(JPATH_COMPONENT.DS.'lib'.DS.'cu3erfile.class.php');

		$slideshow_id = JRequest::getInt('cid');
	
		$mainframe = &JFactory::getApplication();

		// setting CU3ER-config.xml file properties
		$importtype = JRequest::getVar('importtype');		
		$filepath = JRequest::getVar('filepath');
		$pathinfo = pathinfo($filepath);

		// basic redirection link
		$link = 'index.php?option=com_cu3er&view=xmlupdate&cid='.$slideshow_id.'&importtype='.$importtype;
		$error = 'error';
		$xml_file = null;
		$msg = null;

		$slideshow_dir = JPATH_COMPONENT_SITE.DS.'slideshows'.DS.$slideshow_id;
		$slideshow_img_dir = JPATH_SITE.DS.(JComponentHelper::getParams('com_media')->get('image_path')).DS.'CU3ER'.DS.$slideshow_id;

		if ($importtype == 'file') {

			jimport('joomla.filesystem.folder');

			if (JRequest::getInt('state') == 0) {
				$msg = 'You must upload XML file before you update slideshow!';
			} elseif ($pathinfo['extension'] == 'xml') {
				$xml_file = $filepath;
			}
		}

		// handling CU3ER package files
		if ($importtype == 'url' && $msg == null) {		

			$url = JRequest::getVar('url');		
			$status = Cu3erFile::lookup($url); 

			if(!$status) { 
				$msg = 'Failed to connect to website!';
			} elseif ($status[0] >= 400) { 
				$msg = 'File does not exist on that website or is not accessible!';
			} else {
				$xml_file = $url;	
			}
		}

		// validating XML file
		if (!is_null($xml_file) && !Cu3erXML::isXML($xml_file)) {
			 
			$msg = 'CU3ER config file is not a well formed XML file!';		
		
		} elseif (!is_null($xml_file)) {
			
			$msg_xml = 'Unable to copy CU3ER config XML file to /components/com_cu3er/slideshows/[slideshow id]!';

			if ($importtype == 'url') {

				// saving remote XML file
				if (!Cu3erFile::saveRemoteFile($xml_file, $slideshow_dir.DS.basename($xml_file))) {
					$msg = $msg_xml;
				} else {
					$error = false;		
				}				

			} else {			

				if (!JFile::move($xml_file, $slideshow_dir.DS.basename($xml_file))) {
					$msg = $msg_xml;
				} else {
					$error = false;						
				}
			}
		}

		// cleaning up upload folder from temporary files
		if ($importtype != 'url') {
			Cu3erFile::deleteAll(JPATH_COMPONENT_ADMINISTRATOR.DS.'upload', true);
		}

		if ($error) {
			$mainframe->redirect($link, JText::_($msg), $error);
		} else {
			return $slideshow_dir.DS.basename($xml_file);		
		}
	}

	/**
	 * Slideshow XML file upload handler method
	 *
	 * @access	public	
	 */
	function upload() {

		require_once JPATH_COMPONENT.DS.'lib'.DS.'cu3erfile.class.php';
		$slideshow_id = JRequest::getInt('cid');

		// return URL		
		$return	= 'index.php?option=com_cu3er&view=xmlupdate&cid='.$slideshow_id;

		Cu3erFile::uploadFile($return, 'xml', true);
	}

	/**
	 * Slideshow existance checker method
	 *
	 * @access	public
	 * @return 	int ID of existing slideshow	
	 */
	function slideshowExists($slideshow_name) {
		$db = & JFactory::getDBO();
		$name = strtolower($slideshow_name);
		$db->setQuery("SELECT id FROM #__cu3er__slideshows WHERE LOWER(name) = '{$name}'");
		return ($db->loadResult());
	}

}
